<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" 
xmlns:fn="http://www.w3.org/2005/xpath-functions" xmlns:jpdl="http://jbpm.org/4.3/jpdl" xmlns:svg="http://www.w3.org/2000/svg">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	
	<xsl:template match="jpdl:process">
		<svg:svg>
			<svg:defs>
				
				<svg:pattern id="rulerPattern" patternUnits="userSpaceOnUse" x="0" y="0" 
							width="10" height="10" viewBox="0 0 10 10" >
					<svg:line x1="0" y1="0" x2="10" y2="0" stroke="lightblue" fill="none" stroke-dasharray="2,2" />
					<svg:line x1="0" y1="0" x2="0" y2="10" stroke="lightblue" fill="none" stroke-dasharray="2,2" />
				</svg:pattern>
				
				<marker id="arrow-end-marker" viewBox="0 0 10 10" refX="1" refY="5" markerUnits="strokeWidth" orient="auto"
              			markerWidth="4" markerHeight="3">
            		<polyline points="0,0 10,5 0,10 1,5" fill="black" />
        		</marker>

        		<marker id="arrow-mid-marker" viewBox="0 0 10 10" refX="1" refY="5" markerUnits="strokeWidth" orient="auto"
              			markerWidth="4" markerHeight="3">
            		<polyline points="0,0 10,5 0,10 1,5" fill="darkgreen" />
        		</marker>
				
			</svg:defs>
			
			<svg:g>
				<xsl:apply-templates select="//jpdl:transition"/>	
	  			<xsl:apply-templates select="jpdl:start"/>
	  			<xsl:apply-templates select="jpdl:end"/>
	  			<xsl:apply-templates select="jpdl:state"/>
	  			<xsl:apply-templates select="jpdl:hql"/>
	  			<xsl:apply-templates select="jpdl:decision"/>
	  			<xsl:apply-templates select="jpdl:join"/>
	  			<xsl:apply-templates select="jpdl:fork"/>
	  		</svg:g>
			
		</svg:svg>
	</xsl:template>
	
	<xsl:template match="jpdl:start">
	
		<xsl:variable name="x">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="1"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="y">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="2"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="w">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="3"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="h">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="4"/>
			</xsl:call-template>
		</xsl:variable>
		
		<svg:circle cx="{$x + 20}" cy="{$y + 20}" r="20" style="fill:green; opacity:0.4;"/>
		<svg:circle cx="{$x + 20}" cy="{$y + 20}" r="20" style="stroke:darkgreen; opacity:1; fill:none; stroke-width:2;"/>
		
	</xsl:template>
	
	<xsl:template match="jpdl:end">
		
		<xsl:variable name="x">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="1"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="y">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="2"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="w">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="3"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="h">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="4"/>
			</xsl:call-template>
		</xsl:variable>

		<svg:circle cx="{$x + 20}" cy="{$y + 20}" r="20" style="fill:red; opacity:0.4;"/>
		<svg:circle cx="{$x + 20}" cy="{$y + 20}" r="11" style="fill:darkred; stroke:darkred; opacity:1; stroke-width:2;"/>
		<svg:circle cx="{$x + 20}" cy="{$y + 20}" r="20" style="stroke:black; opacity:1; fill:none; stroke-width:2;"/>
			
	</xsl:template>
	
	<xsl:template match="jpdl:decision">
		
		<xsl:variable name="x">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="1"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="y">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="2"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="w">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="3"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="h">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="4"/>
			</xsl:call-template>
		</xsl:variable>

		<svg:rect x="{$x}" y="{$y}" width="40" height="40" style="fill:palegoldenrod; stroke:gold; stroke-width:2;"
					transform="rotate(45 {$x + 20} {$y + 20})"/>
		
	</xsl:template>
	
	<xsl:template match="jpdl:join">
		
		<xsl:variable name="x">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="1"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="y">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="2"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="w">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="3"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="h">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="4"/>
			</xsl:call-template>
		</xsl:variable>

		<svg:rect x="{$x}" y="{$y}" width="40" height="40" style="fill:palegoldenrod; stroke:gold; stroke-width:2;"
					transform="rotate(45 {$x + 20} {$y + 20})"/>
		
	</xsl:template>
	
	<xsl:template match="jpdl:fork">
		
		<xsl:variable name="x">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="1"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="y">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="2"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="w">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="3"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="h">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="4"/>
			</xsl:call-template>
		</xsl:variable>

		<svg:rect x="{$x}" y="{$y}" width="40" height="40" style="fill:palegoldenrod; stroke:gold; stroke-width:2;"
					transform="rotate(45 {$x + 20} {$y + 20})"/>
		
	</xsl:template>
	
	<xsl:template match="jpdl:state">

		<xsl:variable name="x">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="1"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="y">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="2"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="w">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="3"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="h">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="4"/>
			</xsl:call-template>
		</xsl:variable>

		
		
		<svg:rect x="{$x}" y="{$y}" width="{$w}" height="{$h}" rx="10" ry="10" style="fill:lavender; stroke:steelblue; stroke-width:2;"/>
		
		<svg:text  x="{$x + $w div 2}" y="{$y + $h div 2}" dx="0,0,0,0,20" dy="0,0,0,0,8" rotate="20,30,40,50,0,0,-10" 
			textLength="{$w}" lengthAdjust="spacing" font-size="16"  text-anchor="middle" fill = "navy" font-family="Arial">
			<xsl:value-of select="@name"/>
		</svg:text>
		
	</xsl:template>
	
	<xsl:template match="jpdl:hql">

		<xsl:variable name="x">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="1"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="y">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="2"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="w">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="3"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="h">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="@g"/>
				<xsl:with-param name="index" select="4"/>
			</xsl:call-template>
		</xsl:variable>

		
		
		<svg:rect x="{$x}" y="{$y}" width="{$w}" height="{$h}" rx="10" ry="10" style="fill:lavender; stroke:steelblue; stroke-width:2;"/>
		
		<svg:text  x="{$x + $w div 2}" y="{$y + $h div 2}" dx="0,0,0,0,20" dy="0,0,0,0,8" rotate="20,30,40,50,0,0,-10" 
			textLength="{$w}" lengthAdjust="spacing" font-size="16"  text-anchor="middle" fill = "navy" font-family="Arial">
			<xsl:value-of select="@name"/>
		</svg:text>
		
	</xsl:template>
	
	<xsl:key name="dest" match="/jpdl:process/jpdl:*" use="@name"/>
	
	<xsl:template match="//jpdl:transition">
		
		<xsl:variable name="xs">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="../@g"/>
				<xsl:with-param name="index" select="1"/>
			</xsl:call-template>
		</xsl:variable>
		
		<xsl:variable name="ys">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="../@g"/>
				<xsl:with-param name="index" select="2"/>
			</xsl:call-template>
		</xsl:variable>
		
		<xsl:variable name="ws">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="../@g"/>
				<xsl:with-param name="index" select="3"/>
			</xsl:call-template>
		</xsl:variable>
		
		<xsl:variable name="hs">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="../@g"/>
				<xsl:with-param name="index" select="4"/>
			</xsl:call-template>
		</xsl:variable>
		
		<xsl:variable name="xe">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="key('dest',@to)/@g"/>
				<xsl:with-param name="index" select="1"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="ye">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="key('dest',@to)/@g"/>
				<xsl:with-param name="index" select="2"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="we">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="key('dest',@to)/@g"/>
				<xsl:with-param name="index" select="3"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="he">
			<xsl:call-template name="tokinazeAndAtIndex">
				<xsl:with-param name="str" select="key('dest',@to)/@g"/>
				<xsl:with-param name="index" select="4"/>
			</xsl:call-template>
		</xsl:variable>
		
		<xsl:variable name="eox">
			<xsl:choose>
				<xsl:when test="name(key('dest',@to))='state'">
					<xsl:value-of select="$ws div 2"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'20'"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		
		<xsl:variable name="eoy">
			<xsl:choose>
				<xsl:when test="name(key('dest',@to))='state'">
					<xsl:value-of select="$hs div 2"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'20'"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="sox">
			<xsl:choose>
				<xsl:when test="name(..)='state'">
					<xsl:value-of select="$we div 2"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'20'"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		
		<xsl:variable name="soy">
			<xsl:choose>
				<xsl:when test="name(..)='state'">
					<xsl:value-of select="$he div 2"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'20'"/>					
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		

		<svg:path d="M{$xs + $sox},{$ys + $soy}
		 			{translate(substring-before(@g,':'),';',' ')}
					{$xe + $eox},{$ye + $eoy}" style="stroke:darkblue; stroke-width:2;" fill="white"
					marker-mid="url(#arrow-mid-marker)" maker-end="url(#arrow-end-marker)"/>

	</xsl:template>
	
	<xsl:template name="tokinazeAndAtIndex">
		<xsl:param name="str" select="."/>
		<xsl:param name="worddiv" select="','"/>
		<xsl:param name="index"/>
        <xsl:choose>
			<xsl:when test="$index>1 and contains($str,$worddiv)">
				<xsl:call-template name="tokinazeAndAtIndex">
					<xsl:with-param name="str" select="substring-after($str,$worddiv)"/>
					<xsl:with-param name="index" select="$index - 1"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$index=1 and contains($str,$worddiv)">
				<xsl:value-of select="substring-before($str,$worddiv)"/>
			</xsl:when>
			<xsl:when test="$index=1 and not(contains($str,$worddiv))">
				<xsl:value-of select="$str"/>
			</xsl:when>
			<xsl:otherwise>
				error: <xsl:value-of select="$index"/>,<xsl:value-of select="$str"/>
			</xsl:otherwise>
        </xsl:choose>
    </xsl:template>
  	
  	<xsl:template name="splitByComma">
		<xsl:param name="str" select="."/>
		<xsl:param name="worddiv" select="','"/>
        <xsl:choose>
			<xsl:when test="contains($str,$worddiv)">
				<part><xsl:value-of select="substring-before($str,$worddiv)"/></part>
				<xsl:call-template name="splitByComma">
					<xsl:with-param name="str" select="substring-after($str,$worddiv)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<part><xsl:value-of select="$str"/></part>
			</xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    <xsl:template name="splitByColon">
		<xsl:param name="str" select="."/>
		<xsl:param name="worddiv" select="':'"/>
        <xsl:choose>
			<xsl:when test="contains($str,$worddiv)">
				<part><xsl:value-of select="substring-before($str,$worddiv)"/></part>
				<xsl:call-template name="splitByComma">
					<xsl:with-param name="str" select="substring-after($str,$worddiv)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<part><xsl:value-of select="$str"/></part>
			</xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
</xsl:stylesheet>



 
